<?php

	class PECL_Gen_Element_Resource 
    extends PECL_Gen_Element 
  {
	  var $name = "unknown";
		var $payload = "void";
		var $alloc = "yes";
		var $destruct = "";
		var $description = "";

		function set_name($name) 
		{
			if (!self::is_name($name)) {
				return $this->raiseError("'$name' is not a valid resource name");
			}

			$this->name = $name;

			return true;
		}


		function set_payload($type)
		{
			$this->payload = $type;

			return true;
		}
		
		function set_alloc($text)
		{
			$this->alloc = $text;

			return true;
		}

		function set_destruct($text)
		{
			$this->destruct = $text;

			return true;
		}
		
		function set_description($text)
		{
			$this->description = $text;

			return true;
		}
		

		


		function docbook_xml($base) {
			return "
    <section id='$base.resources.{$this->name}'>
     <title><literal>{$this->name}</literal></title>
     <para>
      {$this->description}
     </para>
    </section>
";
		}

		function minit_code() {
			return "
le_{$this->name} = zend_register_list_destructors_ex({$this->name}_dtor, 
                                                     NULL, 
                                                     \"{$this->name}\", 
                                                     module_number);

";
		}

		function c_code() {
			$dtor = "
int le_{$this->name};

void {$this->name}_dtor(zend_rsrc_list_entry *rsrc TSRMLS_DC)
{
  {$this->payload} * resource = ({$this->payload} *)(rsrc->ptr);

  {$this->destruct}
";

      if ($this->alloc === "yes") {
        $dtor .= "  efree(resource);\n";
      }

			$dtor .= "}\n";

      return $dtor;
		}

		function h_code() {
      $upname = strtoupper($this->name);

			return "
#define {$upname}_FETCH(r, z)   ZEND_FETCH_RESOURCE(r, {$this->payload} *, z, -1, ${$this->name}, le_{$this->name}); \
                                    if (!r) { RETURN_FALSE; }

#define {$upname}_REGISTER(r)   ZEND_REGISTER_RESOURCE(return_value, r, le_{$this->name});
";
		}
	}

?>